#ifndef WMGENERAL_H_INCLUDED
#define WMGENERAL_H_INCLUDED

#include <X11/xpm.h>

/***********/
/* Defines */
/***********/

#define MAX_MOUSE_REGION (16)

/************/
/* Typedefs */
/************/

typedef struct _rckeys rckeys;

struct _rckeys {
   const char* label;
   char**      var;
};

typedef struct _rckeys2 rckeys2;

struct _rckeys2 {
   const char* family;
   const char* label;
   char**      var;
};

typedef struct {
   Pixmap        pixmap;
   Pixmap	 mask;
   XpmAttributes attributes;
} XpmIcon;

/*******************/
/* Global variable */
/*******************/

extern Display* display;
extern XpmIcon  wmgen;
extern GC       NormalGC;

/***********************/
/* Function Prototypes */
/***********************/

void AddMouseRegion(int index, int left, int top, int right, int bottom);
int CheckMouseRegion(int x, int y);

void openXwindow(int argc, char *argv[], char **, unsigned char *, int, int);
void RedrawWindow(void);
void RedrawWindowXY(int x, int y);

void createXBMfromXPM(char *, char **, int, int);
void setMaskXY(int, int);

void parse_rcfile(const char *, rckeys *);

#define copyXPMArea(x, y, sx, sy, dx, dy) XCopyArea(display, wmgen.pixmap, \
                                                    wmgen.pixmap, NormalGC, \
	                                            x, y, sx, sy, dx, dy)
#define copyXBMArea(x, y, sx, sy, dx, dy) XCopyArea(display, wmgen.mask, \
                                          wmgen.pixmap, NormalGC, \
                                          x, y, sx, sy, dx, dy)
#endif
